#include <stdio.h>
#include <stdlib.h>

#include <avr/io.h>
#include <util/delay.h>

/*

Matrice - verde
PC5 PC3 PC1
PA3 PA1 PC7
PB1 PA7 PA5

Matrice - galben
PC6 PC4 PC2
PA4 PA2 PA0
PB2 PB0 PA6

PB4 - mod de joc(licare - player vs player, 
aprins - player vs dumb AI, stins - player vs intelligent AI)

Butoane
PC0 - stanga
PD1 - sus
PD0 - dreapta
PD4 - jos

PD5 - select
PB3 - switch mode
*/

void verifica_terminare(int matrice[3][3], int * ok)
{

}

void get_led(int * pin, int * port, int linie, int coloana, int mutare)
{
	/*verde*/
	if (linie == 0 && coloana == 0 && mutare % 2 == 0) 
	{
		pin = PC5;
		port = 2;
		
		return;
	}
	
	if (linie == 0 && coloana == 1 && mutare % 2 == 0) 
	{
		pin = PC3;
		port = 2;
		
		return;
	} 
	
	if (linie == 0 && coloana == 2 && mutare % 2 == 0) 
	{
		pin = PC1;
		port = 3;
		
		return;
	} 
	
	if (linie == 1 && coloana == 0 && mutare % 2 == 0) 
	{
		pin = PA3;
		port = 1;
		
		return;
	} 
	
	if (linie == 1 && coloana == 1 && mutare % 2 == 0) 
	{
		pin = PA1;
		port = 1;
		
		return;
	} 
	
	if (linie == 1 && coloana == 2 && mutare % 2 == 0) 
	{
		pin = PC7;
		port = 3;
		
		return;
	} 
	
	if (linie == 2 && coloana == 0 && mutare % 2 == 0) 
	{
		pin = PB1;
		port = 2;
		
		return;
	} 
	
	if (linie == 2 && coloana == 1 && mutare % 2 == 0) 
	{
		pin = PA7;
		port = 1;
		
		return;
	} 
	
	if (linie == 2 && coloana == 2 && mutare % 2 == 0) 
	{
		pin = PA5;
		port = 1;
		
		return;
	} 
	
	/*galben*/
	if (linie == 0 && coloana == 0 && mutare % 2 == 1) 
	{
		pin = PC6;
		port = 3;
		
		return;
	} 
	
	if (linie == 0 && coloana == 1 && mutare % 2 == 1) 
	{
		pin = PC4;
		port = 3;
		
		return;
	} 
	
	if (linie == 0 && coloana == 2 && mutare % 2 == 1) 
	{
		pin = PC2;
		port = 3;
		
		return;
	} 
	
	if (linie == 1 && coloana == 0 && mutare % 2 == 1) 
	{
		pin = PA4;
		port = 1;
		
		return;
	} 
	
	if (linie == 1 && coloana == 1 && mutare % 2 == 1) 
	{
		pin = PA2;
		port = 1;
		
		return;
	} 
	
	if (linie == 1 && coloana == 2 && mutare % 2 == 1) 
	{
		pin = PA0;
		port = 1;
		
		return;
	} 
	
	if (linie == 2 && coloana == 0 && mutare % 2 == 1) 
	{
		pin = PB2;
		port = 2;
		
		return;
	} 
	
	if (linie == 2 && coloana == 1 && mutare % 2 == 1) 
	{
		pin = PB0;
		port = 2;
		
		return;
	} 
	
	if (linie == 2 && coloana == 2 && mutare % 2 == 1) 
	{
		pin = PA6;
		port = 1;
		
		return;
	}
	
}

int main()
{
	int i, j, linie = 0, coloana = 0, matrice[3][3], init = 0, mutare = 0;
	int pin, port; // port - 0 pentru A, 1 pentru B, 2 pentru C
	int win_line, win_col, win_diag, win_done;
	
	DDRA = 0xff;
	DDRB = 0xff;
	DDRC = 0xff;
	DDRD = 0xff;
	
	/* setam butoanele ca input si activa rezistentele de pull-up */
	
	//buton stanga
	DDRC &= ~(1 << PC0);
	PORTC |= (1 << PC0);
	
	//buton sus
	DDRD &= ~(1 << PD1);
	PORTD |= (1 << PD1);
	
	//buton dreapta
	DDRD &= ~(1 << PD0);
	PORTD |= (1 << PD0);
	
	//buton jos
	DDRD &= ~(1 << PD4);
	PORTD |= (1 << PD4);
	
	//buton select
	DDRD &= ~(1 << PD5);
	PORTD |= (1 << PD5);
	
	win_line = -1;
	win_col = -1;
	win_diag = -1;
	win_done = -1;
	
	for (i = 0; i <= 2; i++)
		for (j = 0; j <= 2; j++)
			matrice[i][j] = 0;
	
	while (1)
	{
		linie = coloana = set = 0;
		
		if (win_done != -1)
			break;
		
		if (init == 0)
		{
			for (i = 0; i <= 2; i++)
				for (j =0; j <= 2; j++)
					if (matrice[i][j] == 0)
					{
						linie = i;
						coloana = j;
						init = 1;
					}
		}
		
		get_led(&pin, &port, linie, coloana, mutare);
		
		//aprindem led
		switch (port) 
		{
			case 0:
				PORTA ^= (1 << pin);
				break;
			case 1:
				PORTB ^= (1 << pin);
				break;
			case 2:
				PORTC ^= (1 << pin);
				break;
			default:
				break;
		}
		
		_delay_ms(250);
		
		/* player vs player */
		while (1)
		{
			//apasare buton stanga
			if (PINC & (1 << PC0) == 0)
			{
				//stingem ledul precedent
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				while(matrice[linie][coloana])
				{
					if (coloana == 0)
						linie -= 1;
						
					if (linie < 0)
						linie = 2;
					
					linie %= 3;
					
					coloana -= 1;
					
					if (coloana < 0)
						coloana = 2;
						
					coloana %= 3;
				}
				
				//aprindem noul led	
				get_led(&pin, &port, linie, coloana, mutare);
				
				//aprindem led
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				_delay_ms(400);
			}
			//apasare buton sus
			if (PIND & (1 << PD1) == 0)
			{
				//stingem ledul precedent
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				while(matrice[linie][coloana])
				{
					if (linie == 0)
						coloana -= 1;
					
					if (coloana < 0)
						coloana = 2;
						
					coloana %= 3;
					
					linie -= 1;
					if (linie < 0)
						linie = 2;
						
					linie %= 3;
				}
				
				//aprindem noul led	
				get_led(&pin, &port, linie, coloana, mutare);
				
				//aprindem led
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				_delay_ms(400);
			}
			//apasare buton dreapta
			if (PIND & (1 << PD0) == 0)
			{
				//stingem ledul precedent
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				while(matrice[linie][coloana])
				{
					if (coloana == 2)
						linie = (linie + 1) % 3;
						
					coloana = (coloana + 1) % 3;
				}
				
				//aprindem noul led	
				get_led(&pin, &port, linie, coloana, mutare);
				
				//aprindem led
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				_delay_ms(400);
			}
			//apasare buton jos
			if (PIND & (1 << PD4) == 0)
			{
				//stingem ledul precedent
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				while(matrice[linie][coloana])
				{
					if (linie == 2)
						coloana = (coloana + 1) % 3;
						
					linie = (linie + 1) % 3;
				}
				
				//aprindem noul led	
				get_led(&pin, &port, linie, coloana, mutare);
				
				//aprindem led
				switch (port) 
				{
					case 0:
						PORTA ^= (1 << pin);
						break;
					case 1:
						PORTB ^= (1 << pin);
						break;
					case 2:
						PORTC ^= (1 << pin);
						break;
					default:
						break;
				}
				
				_delay_ms(400);
			}
			//apasare buton select
			if (PIND & (1 << PD5) == 0)
			{
				if (mutare % 2 == 0)
				{
					matrice[linie][coloana] = -1;
				}
				else
				{
					matrice[linie][coloana] = 1;
				}
				
				verifica_terminare(matrice, &ok);
				
				mutare++;
				break;
			}
			
		}
	}
	
	return 0;
}